/*
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * A client to Google Android Over the Air API.
 *
 * <p>The interfaces provided are listed below, along with usage samples.
 *
 * <p>======================= OverTheAirServiceClient =======================
 *
 * <p>Service Description: ## Service for Android Over the Air(OTA).
 *
 * <p>## ---- deployment related rpcs ---
 *
 * <p>Sample for OverTheAirServiceClient:
 *
 * <pre>
 * <code>
 * try (OverTheAirServiceClient overTheAirServiceClient = OverTheAirServiceClient.create()) {
 *   String formattedName = OverTheAirServiceClient.formatDeploymentName("[DEPLOYMENT]");
 *   View view = View.BASIC;
 *   Deployment response = overTheAirServiceClient.getDeployment(formattedName, view);
 * }
 * </code>
 * </pre>
 */
package com.google.android.overtheair.spi.v1;
