/*
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.google.android.overtheair.spi.v1.stub;

import com.google.android.overtheair.v1.Chart;
import com.google.android.overtheair.v1.Config;
import com.google.android.overtheair.v1.CreateConfigRequest;
import com.google.android.overtheair.v1.CreateGroupMemberRequest;
import com.google.android.overtheair.v1.CreateGroupMembersRequest;
import com.google.android.overtheair.v1.CreateGroupMembersResponse;
import com.google.android.overtheair.v1.CreateGroupRequest;
import com.google.android.overtheair.v1.DeleteConfigRequest;
import com.google.android.overtheair.v1.DeleteConfigResponse;
import com.google.android.overtheair.v1.DeleteGroupMemberRequest;
import com.google.android.overtheair.v1.DeleteGroupMemberResponse;
import com.google.android.overtheair.v1.DeleteGroupMembersRequest;
import com.google.android.overtheair.v1.DeleteGroupMembersResponse;
import com.google.android.overtheair.v1.DeleteGroupRequest;
import com.google.android.overtheair.v1.DeleteGroupResponse;
import com.google.android.overtheair.v1.DeletePackageRequest;
import com.google.android.overtheair.v1.DeletePackageResponse;
import com.google.android.overtheair.v1.Deployment;
import com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest;
import com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse;
import com.google.android.overtheair.v1.DisableGroupsRequest;
import com.google.android.overtheair.v1.DisableGroupsResponse;
import com.google.android.overtheair.v1.EnableGroupsRequest;
import com.google.android.overtheair.v1.EnableGroupsResponse;
import com.google.android.overtheair.v1.GetConfigRequest;
import com.google.android.overtheair.v1.GetDeploymentRequest;
import com.google.android.overtheair.v1.GetGroupChartRequest;
import com.google.android.overtheair.v1.GetGroupMemberRequest;
import com.google.android.overtheair.v1.GetGroupRequest;
import com.google.android.overtheair.v1.GetPackageRequest;
import com.google.android.overtheair.v1.Group;
import com.google.android.overtheair.v1.GroupMember;
import com.google.android.overtheair.v1.ListConfigPackagesRequest;
import com.google.android.overtheair.v1.ListConfigPackagesResponse;
import com.google.android.overtheair.v1.ListConfigsRequest;
import com.google.android.overtheair.v1.ListConfigsResponse;
import com.google.android.overtheair.v1.ListConfigsUsingPackageRequest;
import com.google.android.overtheair.v1.ListConfigsUsingPackageResponse;
import com.google.android.overtheair.v1.ListDeploymentsRequest;
import com.google.android.overtheair.v1.ListDeploymentsResponse;
import com.google.android.overtheair.v1.ListGroupChartsRequest;
import com.google.android.overtheair.v1.ListGroupChartsResponse;
import com.google.android.overtheair.v1.ListGroupConfigsRequest;
import com.google.android.overtheair.v1.ListGroupConfigsResponse;
import com.google.android.overtheair.v1.ListGroupMembersRequest;
import com.google.android.overtheair.v1.ListGroupMembersResponse;
import com.google.android.overtheair.v1.ListGroupsRequest;
import com.google.android.overtheair.v1.ListGroupsResponse;
import com.google.android.overtheair.v1.ListPackagesRequest;
import com.google.android.overtheair.v1.ListPackagesResponse;
import com.google.android.overtheair.v1.UpdateConfigPackagesRequest;
import com.google.android.overtheair.v1.UpdateConfigPackagesResponse;
import com.google.android.overtheair.v1.UpdateConfigRequest;
import com.google.android.overtheair.v1.UpdateDeploymentRequest;
import com.google.android.overtheair.v1.UpdateGroupConfigsRequest;
import com.google.android.overtheair.v1.UpdateGroupConfigsResponse;
import com.google.android.overtheair.v1.UpdateGroupRequest;
import com.google.android.overtheair.v1.UpdatePackageRequest;
import com.google.api.core.BetaApi;
import com.google.api.gax.core.BackgroundResource;
import com.google.api.gax.core.BackgroundResourceAggregation;
import com.google.api.gax.grpc.GrpcCallSettings;
import com.google.api.gax.grpc.GrpcStubCallableFactory;
import com.google.api.gax.rpc.ClientContext;
import com.google.api.gax.rpc.RequestParamsExtractor;
import com.google.api.gax.rpc.UnaryCallable;
import com.google.common.collect.ImmutableMap;
import io.grpc.MethodDescriptor;
import io.grpc.protobuf.ProtoUtils;
import java.io.IOException;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import javax.annotation.Generated;

// AUTO-GENERATED DOCUMENTATION AND CLASS
/**
 * gRPC stub implementation for Google Android Over the Air API.
 *
 * <p>This class is for advanced usage and reflects the underlying API directly.
 */
@Generated("by gapic-generator")
@BetaApi("A restructuring of stub classes is planned, so this may break in the future")
public class GrpcOverTheAirServiceStub extends OverTheAirServiceStub {

  private static final MethodDescriptor<GetDeploymentRequest, Deployment>
      getDeploymentMethodDescriptor =
          MethodDescriptor.<GetDeploymentRequest, Deployment>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/GetDeployment")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(GetDeploymentRequest.getDefaultInstance()))
              .setResponseMarshaller(ProtoUtils.marshaller(Deployment.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<ListDeploymentsRequest, ListDeploymentsResponse>
      listDeploymentsMethodDescriptor =
          MethodDescriptor.<ListDeploymentsRequest, ListDeploymentsResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/ListDeployments")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(ListDeploymentsRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(ListDeploymentsResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<UpdateDeploymentRequest, Deployment>
      updateDeploymentMethodDescriptor =
          MethodDescriptor.<UpdateDeploymentRequest, Deployment>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/UpdateDeployment")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(UpdateDeploymentRequest.getDefaultInstance()))
              .setResponseMarshaller(ProtoUtils.marshaller(Deployment.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<GetPackageRequest, com.google.android.overtheair.v1.Package>
      getPackageMethodDescriptor =
          MethodDescriptor.<GetPackageRequest, com.google.android.overtheair.v1.Package>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/GetPackage")
              .setRequestMarshaller(ProtoUtils.marshaller(GetPackageRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(
                      com.google.android.overtheair.v1.Package.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<ListPackagesRequest, ListPackagesResponse>
      listPackagesMethodDescriptor =
          MethodDescriptor.<ListPackagesRequest, ListPackagesResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/ListPackages")
              .setRequestMarshaller(ProtoUtils.marshaller(ListPackagesRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(ListPackagesResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<DeletePackageRequest, DeletePackageResponse>
      deletePackageMethodDescriptor =
          MethodDescriptor.<DeletePackageRequest, DeletePackageResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/DeletePackage")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(DeletePackageRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(DeletePackageResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<
          UpdatePackageRequest, com.google.android.overtheair.v1.Package>
      updatePackageMethodDescriptor =
          MethodDescriptor
              .<UpdatePackageRequest, com.google.android.overtheair.v1.Package>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/UpdatePackage")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(UpdatePackageRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(
                      com.google.android.overtheair.v1.Package.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<CreateConfigRequest, Config> createConfigMethodDescriptor =
      MethodDescriptor.<CreateConfigRequest, Config>newBuilder()
          .setType(MethodDescriptor.MethodType.UNARY)
          .setFullMethodName("google.android.overtheair.v1.OverTheAirService/CreateConfig")
          .setRequestMarshaller(ProtoUtils.marshaller(CreateConfigRequest.getDefaultInstance()))
          .setResponseMarshaller(ProtoUtils.marshaller(Config.getDefaultInstance()))
          .build();
  private static final MethodDescriptor<GetConfigRequest, Config> getConfigMethodDescriptor =
      MethodDescriptor.<GetConfigRequest, Config>newBuilder()
          .setType(MethodDescriptor.MethodType.UNARY)
          .setFullMethodName("google.android.overtheair.v1.OverTheAirService/GetConfig")
          .setRequestMarshaller(ProtoUtils.marshaller(GetConfigRequest.getDefaultInstance()))
          .setResponseMarshaller(ProtoUtils.marshaller(Config.getDefaultInstance()))
          .build();
  private static final MethodDescriptor<ListConfigsRequest, ListConfigsResponse>
      listConfigsMethodDescriptor =
          MethodDescriptor.<ListConfigsRequest, ListConfigsResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/ListConfigs")
              .setRequestMarshaller(ProtoUtils.marshaller(ListConfigsRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(ListConfigsResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<DeleteConfigRequest, DeleteConfigResponse>
      deleteConfigMethodDescriptor =
          MethodDescriptor.<DeleteConfigRequest, DeleteConfigResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/DeleteConfig")
              .setRequestMarshaller(ProtoUtils.marshaller(DeleteConfigRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(DeleteConfigResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<UpdateConfigRequest, Config> updateConfigMethodDescriptor =
      MethodDescriptor.<UpdateConfigRequest, Config>newBuilder()
          .setType(MethodDescriptor.MethodType.UNARY)
          .setFullMethodName("google.android.overtheair.v1.OverTheAirService/UpdateConfig")
          .setRequestMarshaller(ProtoUtils.marshaller(UpdateConfigRequest.getDefaultInstance()))
          .setResponseMarshaller(ProtoUtils.marshaller(Config.getDefaultInstance()))
          .build();
  private static final MethodDescriptor<CreateGroupRequest, Group> createGroupMethodDescriptor =
      MethodDescriptor.<CreateGroupRequest, Group>newBuilder()
          .setType(MethodDescriptor.MethodType.UNARY)
          .setFullMethodName("google.android.overtheair.v1.OverTheAirService/CreateGroup")
          .setRequestMarshaller(ProtoUtils.marshaller(CreateGroupRequest.getDefaultInstance()))
          .setResponseMarshaller(ProtoUtils.marshaller(Group.getDefaultInstance()))
          .build();
  private static final MethodDescriptor<GetGroupRequest, Group> getGroupMethodDescriptor =
      MethodDescriptor.<GetGroupRequest, Group>newBuilder()
          .setType(MethodDescriptor.MethodType.UNARY)
          .setFullMethodName("google.android.overtheair.v1.OverTheAirService/GetGroup")
          .setRequestMarshaller(ProtoUtils.marshaller(GetGroupRequest.getDefaultInstance()))
          .setResponseMarshaller(ProtoUtils.marshaller(Group.getDefaultInstance()))
          .build();
  private static final MethodDescriptor<ListGroupsRequest, ListGroupsResponse>
      listGroupsMethodDescriptor =
          MethodDescriptor.<ListGroupsRequest, ListGroupsResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/ListGroups")
              .setRequestMarshaller(ProtoUtils.marshaller(ListGroupsRequest.getDefaultInstance()))
              .setResponseMarshaller(ProtoUtils.marshaller(ListGroupsResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<DeleteGroupRequest, DeleteGroupResponse>
      deleteGroupMethodDescriptor =
          MethodDescriptor.<DeleteGroupRequest, DeleteGroupResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/DeleteGroup")
              .setRequestMarshaller(ProtoUtils.marshaller(DeleteGroupRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(DeleteGroupResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<UpdateGroupRequest, Group> updateGroupMethodDescriptor =
      MethodDescriptor.<UpdateGroupRequest, Group>newBuilder()
          .setType(MethodDescriptor.MethodType.UNARY)
          .setFullMethodName("google.android.overtheair.v1.OverTheAirService/UpdateGroup")
          .setRequestMarshaller(ProtoUtils.marshaller(UpdateGroupRequest.getDefaultInstance()))
          .setResponseMarshaller(ProtoUtils.marshaller(Group.getDefaultInstance()))
          .build();
  private static final MethodDescriptor<DisableGroupsRequest, DisableGroupsResponse>
      disableGroupsMethodDescriptor =
          MethodDescriptor.<DisableGroupsRequest, DisableGroupsResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/DisableGroups")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(DisableGroupsRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(DisableGroupsResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<EnableGroupsRequest, EnableGroupsResponse>
      enableGroupsMethodDescriptor =
          MethodDescriptor.<EnableGroupsRequest, EnableGroupsResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/EnableGroups")
              .setRequestMarshaller(ProtoUtils.marshaller(EnableGroupsRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(EnableGroupsResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<CreateGroupMemberRequest, GroupMember>
      createGroupMemberMethodDescriptor =
          MethodDescriptor.<CreateGroupMemberRequest, GroupMember>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/CreateGroupMember")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(CreateGroupMemberRequest.getDefaultInstance()))
              .setResponseMarshaller(ProtoUtils.marshaller(GroupMember.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<CreateGroupMembersRequest, CreateGroupMembersResponse>
      createGroupMembersMethodDescriptor =
          MethodDescriptor.<CreateGroupMembersRequest, CreateGroupMembersResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService/CreateGroupMembers")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(CreateGroupMembersRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(CreateGroupMembersResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<GetGroupMemberRequest, GroupMember>
      getGroupMemberMethodDescriptor =
          MethodDescriptor.<GetGroupMemberRequest, GroupMember>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/GetGroupMember")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(GetGroupMemberRequest.getDefaultInstance()))
              .setResponseMarshaller(ProtoUtils.marshaller(GroupMember.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<ListGroupMembersRequest, ListGroupMembersResponse>
      listGroupMembersMethodDescriptor =
          MethodDescriptor.<ListGroupMembersRequest, ListGroupMembersResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/ListGroupMembers")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(ListGroupMembersRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(ListGroupMembersResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<DeleteGroupMemberRequest, DeleteGroupMemberResponse>
      deleteGroupMemberMethodDescriptor =
          MethodDescriptor.<DeleteGroupMemberRequest, DeleteGroupMemberResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/DeleteGroupMember")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(DeleteGroupMemberRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(DeleteGroupMemberResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<DeleteGroupMembersRequest, DeleteGroupMembersResponse>
      deleteGroupMembersMethodDescriptor =
          MethodDescriptor.<DeleteGroupMembersRequest, DeleteGroupMembersResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService/DeleteGroupMembers")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(DeleteGroupMembersRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(DeleteGroupMembersResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<GetGroupChartRequest, Chart> getGroupChartMethodDescriptor =
      MethodDescriptor.<GetGroupChartRequest, Chart>newBuilder()
          .setType(MethodDescriptor.MethodType.UNARY)
          .setFullMethodName("google.android.overtheair.v1.OverTheAirService/GetGroupChart")
          .setRequestMarshaller(ProtoUtils.marshaller(GetGroupChartRequest.getDefaultInstance()))
          .setResponseMarshaller(ProtoUtils.marshaller(Chart.getDefaultInstance()))
          .build();
  private static final MethodDescriptor<ListGroupChartsRequest, ListGroupChartsResponse>
      listGroupChartsMethodDescriptor =
          MethodDescriptor.<ListGroupChartsRequest, ListGroupChartsResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/ListGroupCharts")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(ListGroupChartsRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(ListGroupChartsResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<ListGroupConfigsRequest, ListGroupConfigsResponse>
      listGroupConfigsMethodDescriptor =
          MethodDescriptor.<ListGroupConfigsRequest, ListGroupConfigsResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName("google.android.overtheair.v1.OverTheAirService/ListGroupConfigs")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(ListGroupConfigsRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(ListGroupConfigsResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse>
      updateGroupConfigsMethodDescriptor =
          MethodDescriptor.<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService/UpdateGroupConfigs")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(UpdateGroupConfigsRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(UpdateGroupConfigsResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<
          DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse>
      disableAllEnabledGroupsOfConfigMethodDescriptor =
          MethodDescriptor
              .<DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse>
                  newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService/DisableAllEnabledGroupsOfConfig")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(
                      DisableAllEnabledGroupsOfConfigRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(
                      DisableAllEnabledGroupsOfConfigResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<ListConfigPackagesRequest, ListConfigPackagesResponse>
      listConfigPackagesMethodDescriptor =
          MethodDescriptor.<ListConfigPackagesRequest, ListConfigPackagesResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService/ListConfigPackages")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(ListConfigPackagesRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(ListConfigPackagesResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse>
      updateConfigPackagesMethodDescriptor =
          MethodDescriptor.<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService/UpdateConfigPackages")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(UpdateConfigPackagesRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(UpdateConfigPackagesResponse.getDefaultInstance()))
              .build();
  private static final MethodDescriptor<
          ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse>
      listConfigsUsingPackageMethodDescriptor =
          MethodDescriptor
              .<ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse>newBuilder()
              .setType(MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService/ListConfigsUsingPackage")
              .setRequestMarshaller(
                  ProtoUtils.marshaller(ListConfigsUsingPackageRequest.getDefaultInstance()))
              .setResponseMarshaller(
                  ProtoUtils.marshaller(ListConfigsUsingPackageResponse.getDefaultInstance()))
              .build();

  private final BackgroundResource backgroundResources;

  private final UnaryCallable<GetDeploymentRequest, Deployment> getDeploymentCallable;
  private final UnaryCallable<ListDeploymentsRequest, ListDeploymentsResponse>
      listDeploymentsCallable;
  private final UnaryCallable<UpdateDeploymentRequest, Deployment> updateDeploymentCallable;
  private final UnaryCallable<GetPackageRequest, com.google.android.overtheair.v1.Package>
      getPackageCallable;
  private final UnaryCallable<ListPackagesRequest, ListPackagesResponse> listPackagesCallable;
  private final UnaryCallable<DeletePackageRequest, DeletePackageResponse> deletePackageCallable;
  private final UnaryCallable<UpdatePackageRequest, com.google.android.overtheair.v1.Package>
      updatePackageCallable;
  private final UnaryCallable<CreateConfigRequest, Config> createConfigCallable;
  private final UnaryCallable<GetConfigRequest, Config> getConfigCallable;
  private final UnaryCallable<ListConfigsRequest, ListConfigsResponse> listConfigsCallable;
  private final UnaryCallable<DeleteConfigRequest, DeleteConfigResponse> deleteConfigCallable;
  private final UnaryCallable<UpdateConfigRequest, Config> updateConfigCallable;
  private final UnaryCallable<CreateGroupRequest, Group> createGroupCallable;
  private final UnaryCallable<GetGroupRequest, Group> getGroupCallable;
  private final UnaryCallable<ListGroupsRequest, ListGroupsResponse> listGroupsCallable;
  private final UnaryCallable<DeleteGroupRequest, DeleteGroupResponse> deleteGroupCallable;
  private final UnaryCallable<UpdateGroupRequest, Group> updateGroupCallable;
  private final UnaryCallable<DisableGroupsRequest, DisableGroupsResponse> disableGroupsCallable;
  private final UnaryCallable<EnableGroupsRequest, EnableGroupsResponse> enableGroupsCallable;
  private final UnaryCallable<CreateGroupMemberRequest, GroupMember> createGroupMemberCallable;
  private final UnaryCallable<CreateGroupMembersRequest, CreateGroupMembersResponse>
      createGroupMembersCallable;
  private final UnaryCallable<GetGroupMemberRequest, GroupMember> getGroupMemberCallable;
  private final UnaryCallable<ListGroupMembersRequest, ListGroupMembersResponse>
      listGroupMembersCallable;
  private final UnaryCallable<DeleteGroupMemberRequest, DeleteGroupMemberResponse>
      deleteGroupMemberCallable;
  private final UnaryCallable<DeleteGroupMembersRequest, DeleteGroupMembersResponse>
      deleteGroupMembersCallable;
  private final UnaryCallable<GetGroupChartRequest, Chart> getGroupChartCallable;
  private final UnaryCallable<ListGroupChartsRequest, ListGroupChartsResponse>
      listGroupChartsCallable;
  private final UnaryCallable<ListGroupConfigsRequest, ListGroupConfigsResponse>
      listGroupConfigsCallable;
  private final UnaryCallable<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse>
      updateGroupConfigsCallable;
  private final UnaryCallable<
          DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse>
      disableAllEnabledGroupsOfConfigCallable;
  private final UnaryCallable<ListConfigPackagesRequest, ListConfigPackagesResponse>
      listConfigPackagesCallable;
  private final UnaryCallable<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse>
      updateConfigPackagesCallable;
  private final UnaryCallable<ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse>
      listConfigsUsingPackageCallable;

  private final GrpcStubCallableFactory callableFactory;

  public static final GrpcOverTheAirServiceStub create(OverTheAirServiceStubSettings settings)
      throws IOException {
    return new GrpcOverTheAirServiceStub(settings, ClientContext.create(settings));
  }

  public static final GrpcOverTheAirServiceStub create(ClientContext clientContext)
      throws IOException {
    return new GrpcOverTheAirServiceStub(
        OverTheAirServiceStubSettings.newBuilder().build(), clientContext);
  }

  public static final GrpcOverTheAirServiceStub create(
      ClientContext clientContext, GrpcStubCallableFactory callableFactory) throws IOException {
    return new GrpcOverTheAirServiceStub(
        OverTheAirServiceStubSettings.newBuilder().build(), clientContext, callableFactory);
  }

  /**
   * Constructs an instance of GrpcOverTheAirServiceStub, using the given settings. This is
   * protected so that it is easy to make a subclass, but otherwise, the static factory methods
   * should be preferred.
   */
  protected GrpcOverTheAirServiceStub(
      OverTheAirServiceStubSettings settings, ClientContext clientContext) throws IOException {
    this(settings, clientContext, new GrpcOverTheAirServiceCallableFactory());
  }

  /**
   * Constructs an instance of GrpcOverTheAirServiceStub, using the given settings. This is
   * protected so that it is easy to make a subclass, but otherwise, the static factory methods
   * should be preferred.
   */
  protected GrpcOverTheAirServiceStub(
      OverTheAirServiceStubSettings settings,
      ClientContext clientContext,
      GrpcStubCallableFactory callableFactory)
      throws IOException {
    this.callableFactory = callableFactory;

    GrpcCallSettings<GetDeploymentRequest, Deployment> getDeploymentTransportSettings =
        GrpcCallSettings.<GetDeploymentRequest, Deployment>newBuilder()
            .setMethodDescriptor(getDeploymentMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<GetDeploymentRequest>() {
                  @Override
                  public Map<String, String> extract(GetDeploymentRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<ListDeploymentsRequest, ListDeploymentsResponse>
        listDeploymentsTransportSettings =
            GrpcCallSettings.<ListDeploymentsRequest, ListDeploymentsResponse>newBuilder()
                .setMethodDescriptor(listDeploymentsMethodDescriptor)
                .build();
    GrpcCallSettings<UpdateDeploymentRequest, Deployment> updateDeploymentTransportSettings =
        GrpcCallSettings.<UpdateDeploymentRequest, Deployment>newBuilder()
            .setMethodDescriptor(updateDeploymentMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<UpdateDeploymentRequest>() {
                  @Override
                  public Map<String, String> extract(UpdateDeploymentRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<GetPackageRequest, com.google.android.overtheair.v1.Package>
        getPackageTransportSettings =
            GrpcCallSettings
                .<GetPackageRequest, com.google.android.overtheair.v1.Package>newBuilder()
                .setMethodDescriptor(getPackageMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<GetPackageRequest>() {
                      @Override
                      public Map<String, String> extract(GetPackageRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<ListPackagesRequest, ListPackagesResponse> listPackagesTransportSettings =
        GrpcCallSettings.<ListPackagesRequest, ListPackagesResponse>newBuilder()
            .setMethodDescriptor(listPackagesMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<ListPackagesRequest>() {
                  @Override
                  public Map<String, String> extract(ListPackagesRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<DeletePackageRequest, DeletePackageResponse> deletePackageTransportSettings =
        GrpcCallSettings.<DeletePackageRequest, DeletePackageResponse>newBuilder()
            .setMethodDescriptor(deletePackageMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<DeletePackageRequest>() {
                  @Override
                  public Map<String, String> extract(DeletePackageRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<UpdatePackageRequest, com.google.android.overtheair.v1.Package>
        updatePackageTransportSettings =
            GrpcCallSettings
                .<UpdatePackageRequest, com.google.android.overtheair.v1.Package>newBuilder()
                .setMethodDescriptor(updatePackageMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<UpdatePackageRequest>() {
                      @Override
                      public Map<String, String> extract(UpdatePackageRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<CreateConfigRequest, Config> createConfigTransportSettings =
        GrpcCallSettings.<CreateConfigRequest, Config>newBuilder()
            .setMethodDescriptor(createConfigMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<CreateConfigRequest>() {
                  @Override
                  public Map<String, String> extract(CreateConfigRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<GetConfigRequest, Config> getConfigTransportSettings =
        GrpcCallSettings.<GetConfigRequest, Config>newBuilder()
            .setMethodDescriptor(getConfigMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<GetConfigRequest>() {
                  @Override
                  public Map<String, String> extract(GetConfigRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<ListConfigsRequest, ListConfigsResponse> listConfigsTransportSettings =
        GrpcCallSettings.<ListConfigsRequest, ListConfigsResponse>newBuilder()
            .setMethodDescriptor(listConfigsMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<ListConfigsRequest>() {
                  @Override
                  public Map<String, String> extract(ListConfigsRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<DeleteConfigRequest, DeleteConfigResponse> deleteConfigTransportSettings =
        GrpcCallSettings.<DeleteConfigRequest, DeleteConfigResponse>newBuilder()
            .setMethodDescriptor(deleteConfigMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<DeleteConfigRequest>() {
                  @Override
                  public Map<String, String> extract(DeleteConfigRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<UpdateConfigRequest, Config> updateConfigTransportSettings =
        GrpcCallSettings.<UpdateConfigRequest, Config>newBuilder()
            .setMethodDescriptor(updateConfigMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<UpdateConfigRequest>() {
                  @Override
                  public Map<String, String> extract(UpdateConfigRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<CreateGroupRequest, Group> createGroupTransportSettings =
        GrpcCallSettings.<CreateGroupRequest, Group>newBuilder()
            .setMethodDescriptor(createGroupMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<CreateGroupRequest>() {
                  @Override
                  public Map<String, String> extract(CreateGroupRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<GetGroupRequest, Group> getGroupTransportSettings =
        GrpcCallSettings.<GetGroupRequest, Group>newBuilder()
            .setMethodDescriptor(getGroupMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<GetGroupRequest>() {
                  @Override
                  public Map<String, String> extract(GetGroupRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<ListGroupsRequest, ListGroupsResponse> listGroupsTransportSettings =
        GrpcCallSettings.<ListGroupsRequest, ListGroupsResponse>newBuilder()
            .setMethodDescriptor(listGroupsMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<ListGroupsRequest>() {
                  @Override
                  public Map<String, String> extract(ListGroupsRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<DeleteGroupRequest, DeleteGroupResponse> deleteGroupTransportSettings =
        GrpcCallSettings.<DeleteGroupRequest, DeleteGroupResponse>newBuilder()
            .setMethodDescriptor(deleteGroupMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<DeleteGroupRequest>() {
                  @Override
                  public Map<String, String> extract(DeleteGroupRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<UpdateGroupRequest, Group> updateGroupTransportSettings =
        GrpcCallSettings.<UpdateGroupRequest, Group>newBuilder()
            .setMethodDescriptor(updateGroupMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<UpdateGroupRequest>() {
                  @Override
                  public Map<String, String> extract(UpdateGroupRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<DisableGroupsRequest, DisableGroupsResponse> disableGroupsTransportSettings =
        GrpcCallSettings.<DisableGroupsRequest, DisableGroupsResponse>newBuilder()
            .setMethodDescriptor(disableGroupsMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<DisableGroupsRequest>() {
                  @Override
                  public Map<String, String> extract(DisableGroupsRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<EnableGroupsRequest, EnableGroupsResponse> enableGroupsTransportSettings =
        GrpcCallSettings.<EnableGroupsRequest, EnableGroupsResponse>newBuilder()
            .setMethodDescriptor(enableGroupsMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<EnableGroupsRequest>() {
                  @Override
                  public Map<String, String> extract(EnableGroupsRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<CreateGroupMemberRequest, GroupMember> createGroupMemberTransportSettings =
        GrpcCallSettings.<CreateGroupMemberRequest, GroupMember>newBuilder()
            .setMethodDescriptor(createGroupMemberMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<CreateGroupMemberRequest>() {
                  @Override
                  public Map<String, String> extract(CreateGroupMemberRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<CreateGroupMembersRequest, CreateGroupMembersResponse>
        createGroupMembersTransportSettings =
            GrpcCallSettings.<CreateGroupMembersRequest, CreateGroupMembersResponse>newBuilder()
                .setMethodDescriptor(createGroupMembersMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<CreateGroupMembersRequest>() {
                      @Override
                      public Map<String, String> extract(CreateGroupMembersRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<GetGroupMemberRequest, GroupMember> getGroupMemberTransportSettings =
        GrpcCallSettings.<GetGroupMemberRequest, GroupMember>newBuilder()
            .setMethodDescriptor(getGroupMemberMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<GetGroupMemberRequest>() {
                  @Override
                  public Map<String, String> extract(GetGroupMemberRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<ListGroupMembersRequest, ListGroupMembersResponse>
        listGroupMembersTransportSettings =
            GrpcCallSettings.<ListGroupMembersRequest, ListGroupMembersResponse>newBuilder()
                .setMethodDescriptor(listGroupMembersMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<ListGroupMembersRequest>() {
                      @Override
                      public Map<String, String> extract(ListGroupMembersRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<DeleteGroupMemberRequest, DeleteGroupMemberResponse>
        deleteGroupMemberTransportSettings =
            GrpcCallSettings.<DeleteGroupMemberRequest, DeleteGroupMemberResponse>newBuilder()
                .setMethodDescriptor(deleteGroupMemberMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<DeleteGroupMemberRequest>() {
                      @Override
                      public Map<String, String> extract(DeleteGroupMemberRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<DeleteGroupMembersRequest, DeleteGroupMembersResponse>
        deleteGroupMembersTransportSettings =
            GrpcCallSettings.<DeleteGroupMembersRequest, DeleteGroupMembersResponse>newBuilder()
                .setMethodDescriptor(deleteGroupMembersMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<DeleteGroupMembersRequest>() {
                      @Override
                      public Map<String, String> extract(DeleteGroupMembersRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<GetGroupChartRequest, Chart> getGroupChartTransportSettings =
        GrpcCallSettings.<GetGroupChartRequest, Chart>newBuilder()
            .setMethodDescriptor(getGroupChartMethodDescriptor)
            .setParamsExtractor(
                new RequestParamsExtractor<GetGroupChartRequest>() {
                  @Override
                  public Map<String, String> extract(GetGroupChartRequest request) {
                    ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                    params.put("name", String.valueOf(request.getName()));
                    return params.build();
                  }
                })
            .build();
    GrpcCallSettings<ListGroupChartsRequest, ListGroupChartsResponse>
        listGroupChartsTransportSettings =
            GrpcCallSettings.<ListGroupChartsRequest, ListGroupChartsResponse>newBuilder()
                .setMethodDescriptor(listGroupChartsMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<ListGroupChartsRequest>() {
                      @Override
                      public Map<String, String> extract(ListGroupChartsRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<ListGroupConfigsRequest, ListGroupConfigsResponse>
        listGroupConfigsTransportSettings =
            GrpcCallSettings.<ListGroupConfigsRequest, ListGroupConfigsResponse>newBuilder()
                .setMethodDescriptor(listGroupConfigsMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<ListGroupConfigsRequest>() {
                      @Override
                      public Map<String, String> extract(ListGroupConfigsRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse>
        updateGroupConfigsTransportSettings =
            GrpcCallSettings.<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse>newBuilder()
                .setMethodDescriptor(updateGroupConfigsMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<UpdateGroupConfigsRequest>() {
                      @Override
                      public Map<String, String> extract(UpdateGroupConfigsRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<
            DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse>
        disableAllEnabledGroupsOfConfigTransportSettings =
            GrpcCallSettings
                .<DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse>
                    newBuilder()
                .setMethodDescriptor(disableAllEnabledGroupsOfConfigMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<DisableAllEnabledGroupsOfConfigRequest>() {
                      @Override
                      public Map<String, String> extract(
                          DisableAllEnabledGroupsOfConfigRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<ListConfigPackagesRequest, ListConfigPackagesResponse>
        listConfigPackagesTransportSettings =
            GrpcCallSettings.<ListConfigPackagesRequest, ListConfigPackagesResponse>newBuilder()
                .setMethodDescriptor(listConfigPackagesMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<ListConfigPackagesRequest>() {
                      @Override
                      public Map<String, String> extract(ListConfigPackagesRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse>
        updateConfigPackagesTransportSettings =
            GrpcCallSettings.<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse>newBuilder()
                .setMethodDescriptor(updateConfigPackagesMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<UpdateConfigPackagesRequest>() {
                      @Override
                      public Map<String, String> extract(UpdateConfigPackagesRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();
    GrpcCallSettings<ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse>
        listConfigsUsingPackageTransportSettings =
            GrpcCallSettings
                .<ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse>newBuilder()
                .setMethodDescriptor(listConfigsUsingPackageMethodDescriptor)
                .setParamsExtractor(
                    new RequestParamsExtractor<ListConfigsUsingPackageRequest>() {
                      @Override
                      public Map<String, String> extract(ListConfigsUsingPackageRequest request) {
                        ImmutableMap.Builder<String, String> params = ImmutableMap.builder();
                        params.put("name", String.valueOf(request.getName()));
                        return params.build();
                      }
                    })
                .build();

    this.getDeploymentCallable =
        callableFactory.createUnaryCallable(
            getDeploymentTransportSettings, settings.getDeploymentSettings(), clientContext);
    this.listDeploymentsCallable =
        callableFactory.createUnaryCallable(
            listDeploymentsTransportSettings, settings.listDeploymentsSettings(), clientContext);
    this.updateDeploymentCallable =
        callableFactory.createUnaryCallable(
            updateDeploymentTransportSettings, settings.updateDeploymentSettings(), clientContext);
    this.getPackageCallable =
        callableFactory.createUnaryCallable(
            getPackageTransportSettings, settings.getPackageSettings(), clientContext);
    this.listPackagesCallable =
        callableFactory.createUnaryCallable(
            listPackagesTransportSettings, settings.listPackagesSettings(), clientContext);
    this.deletePackageCallable =
        callableFactory.createUnaryCallable(
            deletePackageTransportSettings, settings.deletePackageSettings(), clientContext);
    this.updatePackageCallable =
        callableFactory.createUnaryCallable(
            updatePackageTransportSettings, settings.updatePackageSettings(), clientContext);
    this.createConfigCallable =
        callableFactory.createUnaryCallable(
            createConfigTransportSettings, settings.createConfigSettings(), clientContext);
    this.getConfigCallable =
        callableFactory.createUnaryCallable(
            getConfigTransportSettings, settings.getConfigSettings(), clientContext);
    this.listConfigsCallable =
        callableFactory.createUnaryCallable(
            listConfigsTransportSettings, settings.listConfigsSettings(), clientContext);
    this.deleteConfigCallable =
        callableFactory.createUnaryCallable(
            deleteConfigTransportSettings, settings.deleteConfigSettings(), clientContext);
    this.updateConfigCallable =
        callableFactory.createUnaryCallable(
            updateConfigTransportSettings, settings.updateConfigSettings(), clientContext);
    this.createGroupCallable =
        callableFactory.createUnaryCallable(
            createGroupTransportSettings, settings.createGroupSettings(), clientContext);
    this.getGroupCallable =
        callableFactory.createUnaryCallable(
            getGroupTransportSettings, settings.getGroupSettings(), clientContext);
    this.listGroupsCallable =
        callableFactory.createUnaryCallable(
            listGroupsTransportSettings, settings.listGroupsSettings(), clientContext);
    this.deleteGroupCallable =
        callableFactory.createUnaryCallable(
            deleteGroupTransportSettings, settings.deleteGroupSettings(), clientContext);
    this.updateGroupCallable =
        callableFactory.createUnaryCallable(
            updateGroupTransportSettings, settings.updateGroupSettings(), clientContext);
    this.disableGroupsCallable =
        callableFactory.createUnaryCallable(
            disableGroupsTransportSettings, settings.disableGroupsSettings(), clientContext);
    this.enableGroupsCallable =
        callableFactory.createUnaryCallable(
            enableGroupsTransportSettings, settings.enableGroupsSettings(), clientContext);
    this.createGroupMemberCallable =
        callableFactory.createUnaryCallable(
            createGroupMemberTransportSettings,
            settings.createGroupMemberSettings(),
            clientContext);
    this.createGroupMembersCallable =
        callableFactory.createUnaryCallable(
            createGroupMembersTransportSettings,
            settings.createGroupMembersSettings(),
            clientContext);
    this.getGroupMemberCallable =
        callableFactory.createUnaryCallable(
            getGroupMemberTransportSettings, settings.getGroupMemberSettings(), clientContext);
    this.listGroupMembersCallable =
        callableFactory.createUnaryCallable(
            listGroupMembersTransportSettings, settings.listGroupMembersSettings(), clientContext);
    this.deleteGroupMemberCallable =
        callableFactory.createUnaryCallable(
            deleteGroupMemberTransportSettings,
            settings.deleteGroupMemberSettings(),
            clientContext);
    this.deleteGroupMembersCallable =
        callableFactory.createUnaryCallable(
            deleteGroupMembersTransportSettings,
            settings.deleteGroupMembersSettings(),
            clientContext);
    this.getGroupChartCallable =
        callableFactory.createUnaryCallable(
            getGroupChartTransportSettings, settings.getGroupChartSettings(), clientContext);
    this.listGroupChartsCallable =
        callableFactory.createUnaryCallable(
            listGroupChartsTransportSettings, settings.listGroupChartsSettings(), clientContext);
    this.listGroupConfigsCallable =
        callableFactory.createUnaryCallable(
            listGroupConfigsTransportSettings, settings.listGroupConfigsSettings(), clientContext);
    this.updateGroupConfigsCallable =
        callableFactory.createUnaryCallable(
            updateGroupConfigsTransportSettings,
            settings.updateGroupConfigsSettings(),
            clientContext);
    this.disableAllEnabledGroupsOfConfigCallable =
        callableFactory.createUnaryCallable(
            disableAllEnabledGroupsOfConfigTransportSettings,
            settings.disableAllEnabledGroupsOfConfigSettings(),
            clientContext);
    this.listConfigPackagesCallable =
        callableFactory.createUnaryCallable(
            listConfigPackagesTransportSettings,
            settings.listConfigPackagesSettings(),
            clientContext);
    this.updateConfigPackagesCallable =
        callableFactory.createUnaryCallable(
            updateConfigPackagesTransportSettings,
            settings.updateConfigPackagesSettings(),
            clientContext);
    this.listConfigsUsingPackageCallable =
        callableFactory.createUnaryCallable(
            listConfigsUsingPackageTransportSettings,
            settings.listConfigsUsingPackageSettings(),
            clientContext);

    backgroundResources = new BackgroundResourceAggregation(clientContext.getBackgroundResources());
  }

  public UnaryCallable<GetDeploymentRequest, Deployment> getDeploymentCallable() {
    return getDeploymentCallable;
  }

  public UnaryCallable<ListDeploymentsRequest, ListDeploymentsResponse> listDeploymentsCallable() {
    return listDeploymentsCallable;
  }

  public UnaryCallable<UpdateDeploymentRequest, Deployment> updateDeploymentCallable() {
    return updateDeploymentCallable;
  }

  public UnaryCallable<GetPackageRequest, com.google.android.overtheair.v1.Package>
      getPackageCallable() {
    return getPackageCallable;
  }

  public UnaryCallable<ListPackagesRequest, ListPackagesResponse> listPackagesCallable() {
    return listPackagesCallable;
  }

  public UnaryCallable<DeletePackageRequest, DeletePackageResponse> deletePackageCallable() {
    return deletePackageCallable;
  }

  public UnaryCallable<UpdatePackageRequest, com.google.android.overtheair.v1.Package>
      updatePackageCallable() {
    return updatePackageCallable;
  }

  public UnaryCallable<CreateConfigRequest, Config> createConfigCallable() {
    return createConfigCallable;
  }

  public UnaryCallable<GetConfigRequest, Config> getConfigCallable() {
    return getConfigCallable;
  }

  public UnaryCallable<ListConfigsRequest, ListConfigsResponse> listConfigsCallable() {
    return listConfigsCallable;
  }

  public UnaryCallable<DeleteConfigRequest, DeleteConfigResponse> deleteConfigCallable() {
    return deleteConfigCallable;
  }

  public UnaryCallable<UpdateConfigRequest, Config> updateConfigCallable() {
    return updateConfigCallable;
  }

  public UnaryCallable<CreateGroupRequest, Group> createGroupCallable() {
    return createGroupCallable;
  }

  public UnaryCallable<GetGroupRequest, Group> getGroupCallable() {
    return getGroupCallable;
  }

  public UnaryCallable<ListGroupsRequest, ListGroupsResponse> listGroupsCallable() {
    return listGroupsCallable;
  }

  public UnaryCallable<DeleteGroupRequest, DeleteGroupResponse> deleteGroupCallable() {
    return deleteGroupCallable;
  }

  public UnaryCallable<UpdateGroupRequest, Group> updateGroupCallable() {
    return updateGroupCallable;
  }

  public UnaryCallable<DisableGroupsRequest, DisableGroupsResponse> disableGroupsCallable() {
    return disableGroupsCallable;
  }

  public UnaryCallable<EnableGroupsRequest, EnableGroupsResponse> enableGroupsCallable() {
    return enableGroupsCallable;
  }

  public UnaryCallable<CreateGroupMemberRequest, GroupMember> createGroupMemberCallable() {
    return createGroupMemberCallable;
  }

  public UnaryCallable<CreateGroupMembersRequest, CreateGroupMembersResponse>
      createGroupMembersCallable() {
    return createGroupMembersCallable;
  }

  public UnaryCallable<GetGroupMemberRequest, GroupMember> getGroupMemberCallable() {
    return getGroupMemberCallable;
  }

  public UnaryCallable<ListGroupMembersRequest, ListGroupMembersResponse>
      listGroupMembersCallable() {
    return listGroupMembersCallable;
  }

  public UnaryCallable<DeleteGroupMemberRequest, DeleteGroupMemberResponse>
      deleteGroupMemberCallable() {
    return deleteGroupMemberCallable;
  }

  public UnaryCallable<DeleteGroupMembersRequest, DeleteGroupMembersResponse>
      deleteGroupMembersCallable() {
    return deleteGroupMembersCallable;
  }

  public UnaryCallable<GetGroupChartRequest, Chart> getGroupChartCallable() {
    return getGroupChartCallable;
  }

  public UnaryCallable<ListGroupChartsRequest, ListGroupChartsResponse> listGroupChartsCallable() {
    return listGroupChartsCallable;
  }

  public UnaryCallable<ListGroupConfigsRequest, ListGroupConfigsResponse>
      listGroupConfigsCallable() {
    return listGroupConfigsCallable;
  }

  public UnaryCallable<UpdateGroupConfigsRequest, UpdateGroupConfigsResponse>
      updateGroupConfigsCallable() {
    return updateGroupConfigsCallable;
  }

  public UnaryCallable<
          DisableAllEnabledGroupsOfConfigRequest, DisableAllEnabledGroupsOfConfigResponse>
      disableAllEnabledGroupsOfConfigCallable() {
    return disableAllEnabledGroupsOfConfigCallable;
  }

  public UnaryCallable<ListConfigPackagesRequest, ListConfigPackagesResponse>
      listConfigPackagesCallable() {
    return listConfigPackagesCallable;
  }

  public UnaryCallable<UpdateConfigPackagesRequest, UpdateConfigPackagesResponse>
      updateConfigPackagesCallable() {
    return updateConfigPackagesCallable;
  }

  public UnaryCallable<ListConfigsUsingPackageRequest, ListConfigsUsingPackageResponse>
      listConfigsUsingPackageCallable() {
    return listConfigsUsingPackageCallable;
  }

  @Override
  public final void close() {
    shutdown();
  }

  @Override
  public void shutdown() {
    backgroundResources.shutdown();
  }

  @Override
  public boolean isShutdown() {
    return backgroundResources.isShutdown();
  }

  @Override
  public boolean isTerminated() {
    return backgroundResources.isTerminated();
  }

  @Override
  public void shutdownNow() {
    backgroundResources.shutdownNow();
  }

  @Override
  public boolean awaitTermination(long duration, TimeUnit unit) throws InterruptedException {
    return backgroundResources.awaitTermination(duration, unit);
  }
}
